package com.ruoyi.quartz.task;

import com.ruoyi.system.domain.*;
import com.ruoyi.system.mapper.FcryMapper;
import com.ruoyi.system.mapper.GldryMapper;
import com.ruoyi.system.mapper.JcglryMapper;
import com.ruoyi.system.mapper.YxryMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 定时任务调度
 * 
 * @author ruoyi
 */
@Component("jcglTask")
public class JcglTask
{

    @Autowired
    private JcglryMapper jcglryMapper;
    @Autowired
    private YxryMapper yxryMapper;
    @Autowired
    private GldryMapper gldryMapper;
    @Autowired
    private FcryMapper fcryMapper;
    public void updateAddress()
    {
        System.out.println("定时执行同步隔离人员");
        List<Jcglry> list = jcglryMapper.selectAllJcglry();
        List<Yxry> yxries = yxryMapper.selectAll();
        List<Jcglry> jcglries = new ArrayList<>();
        List<Yxry> yxrys = new ArrayList<>();
        for (Jcglry jcglry : list) {
            List<Yxry> yxrieList = yxries.stream().filter(l->l.getCardNo()!=null&&l.getCardNo().equals(jcglry.getCardNo()))
                    .collect(Collectors.toList());
            if (!yxrieList.isEmpty()){
                jcglry.setStreet(yxrieList.get(0).getStreet());
                jcglry.setCommittee(yxrieList.get(0).getCommittee());
                jcglry.setCommunity(yxrieList.get(0).getCommunity());
                jcglry.setBuilding(yxrieList.get(0).getBuilding());
                jcglry.setUnit(yxrieList.get(0).getUnit());
                jcglry.setHouse(yxrieList.get(0).getHouse());
                jcglry.setFloor(yxrieList.get(0).getFloor());
                if ("1".equals(yxrieList.get(0).getArea())){
                    jcglry.setIsArea("0");
                }
                jcglries.add(jcglry);
//                yxrys.addAll(yxries);
            }
        }
        //更新解除隔离人员地址
        if (!jcglries.isEmpty()){
            int toIndex = 500;
            for (int i = 0; i < jcglries.size(); i += 500) {
                if (i + 500 > jcglries.size()) {
                    toIndex = jcglries.size() - i;
                }
                List<Jcglry> list1 = jcglries.subList(i, i + toIndex);
                jcglryMapper.updateBatch(list1);
            }
        }
        //更新阳性是否解除隔离
        for (Yxry yxry : yxries) {
            List<Jcglry> jcglryList = list.stream().filter(l->l.getCardNo()!=null&&l.getCardNo().equals(yxry.getCardNo()))
                    .collect(Collectors.toList());
            if (!jcglryList.isEmpty())
                yxry.setIsDeisolation("1");
            else
                yxry.setIsDeisolation("0");
        }
        if (!yxries.isEmpty()){
            int toIndex = 500;
            for (int i = 0; i < yxries.size(); i += 500) {
                if (i + 500 > yxries.size()) {
                    toIndex = yxries.size() - i;
                }
                List<Yxry> list1 = yxries.subList(i, i + toIndex);
                yxryMapper.updateBatch(list1);
            }
        }
        //更新方舱人员会否阳性
        List<Fcry> fcries = new ArrayList<>();
        List<Fcry> fcryList = fcryMapper.selectAll();
        for (Fcry fcry : fcryList) {
            List<Yxry> yxrieList = yxries.stream().filter(l->l.getCardNo()!=null&&l.getCardNo().equals(fcry.getCardNo()))
                    .collect(Collectors.toList());
            if (!yxrieList.isEmpty())
                fcry.setIsPositive("1");
            else
                fcry.setIsPositive("0");
            fcries.add(fcry);
        }
        if (!fcries.isEmpty()){
            int toIndex = 500;
            for (int i = 0; i < fcries.size(); i += 500) {
                if (i + 500 > fcries.size()) {
                    toIndex = fcries.size() - i;
                }
                List<Fcry> list1 = fcries.subList(i, i + toIndex);
                fcryMapper.updateBatch(list1);
            }
        }
        //更新隔离点人员是否阳性
        List<Gldry> gldries = new ArrayList<>();
        List<Gldry> gldryList = gldryMapper.selectAll();
        for (Gldry gldry : gldryList) {
            List<Yxry> yxrieList = yxries.stream().filter(l->l.getCardNo()!=null&&l.getCardNo().equals(gldry.getCardNo()))
                    .collect(Collectors.toList());
            if (!yxrieList.isEmpty())
                gldry.setIsYx("1");
            else
                gldry.setIsYx("0");
            gldries.add(gldry);
        }
        if (!gldries.isEmpty()){
            int toIndex = 500;
            for (int i = 0; i < gldries.size(); i += 500) {
                if (i + 500 > gldries.size()) {
                    toIndex = gldries.size() - i;
                }
                List<Gldry> list1 = gldries.subList(i, i + toIndex);
                gldryMapper.updateBatch(list1);
            }
        }
    }
}
